/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.naming.api.PBinder;
import org.objectweb.jorm.naming.api.PExceptionNaming;
import org.objectweb.jorm.api.PExceptionProtocol;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;
import org.objectweb.jorm.naming.api.PNameCoder;
import org.objectweb.jorm.api.PSerializable;
import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PAccessorGen;
import org.objectweb.jorm.api.PClassMapping;

public class Olstore_itemSerializable implements PSerializable, Olstore_itemAccessor {

	//the pname of the object
	protected String pName;
	
		protected java.lang.Integer itemId;
			protected  String jonasCMROrder_Item;
			protected  String jonasCMRUser_Item;
			protected java.lang.String longDesc;
			protected java.lang.Boolean mainPage;
			protected java.lang.String name;
			protected  String pictures;
			protected java.math.BigDecimal price;
			protected  String properties;
			protected java.lang.String shortDesc;
			protected java.lang.Boolean specialOffer;
			protected  String typeId;
	
	public String setPName(PName pName){
		if(pName.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				this.pName  = pName.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			this.pName = "null";
		}
		return this.pName;
	}
	
	public PName getPName(PBinder pnc) throws PExceptionNaming{
		try{
			return pnc.decodeString(pName);
		}catch (Exception e) {
              throw new PExceptionNaming("Cannot decode to a PName: " + e.getMessage());
        }
	}
	
	public String getClassName(){
		return "jorm.Olstore_item";
	}
	

	public void paSetItemId(java.lang.Integer val){
		itemId = val;
	}
	public java.lang.Integer paGetItemId() {
		return itemId;
	}

	public void paSetJonasCMROrder_Item(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				jonasCMROrder_Item = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			jonasCMROrder_Item = "null";
		}
	}
	
	public PName paGetJonasCMROrder_Item(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("jonasCMROrder_Item");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(jonasCMROrder_Item);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetJonasCMRUser_Item(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				jonasCMRUser_Item = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			jonasCMRUser_Item = "null";
		}
	}
	
	public PName paGetJonasCMRUser_Item(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("jonasCMRUser_Item");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(jonasCMRUser_Item);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetLongDesc(java.lang.String val){
		longDesc = val;
	}
	public java.lang.String paGetLongDesc() {
		return longDesc;
	}

	public void paSetMainPage(java.lang.Boolean val){
		mainPage = val;
	}
	public java.lang.Boolean paGetMainPage() {
		return mainPage;
	}

	public void paSetName(java.lang.String val){
		name = val;
	}
	public java.lang.String paGetName() {
		return name;
	}

	public void paSetPictures(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				pictures = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			pictures = "null";
		}
	}
	
	public PName paGetPictures(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("pictures");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(pictures);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetPrice(java.math.BigDecimal val){
		price = val;
	}
	public java.math.BigDecimal paGetPrice() {
		return price;
	}

	public void paSetProperties(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				properties = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			properties = "null";
		}
	}
	
	public PName paGetProperties(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("properties");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(properties);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetShortDesc(java.lang.String val){
		shortDesc = val;
	}
	public java.lang.String paGetShortDesc() {
		return shortDesc;
	}

	public void paSetSpecialOffer(java.lang.Boolean val){
		specialOffer = val;
	}
	public java.lang.Boolean paGetSpecialOffer() {
		return specialOffer;
	}

	public void paSetTypeId(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				typeId = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			typeId = "null";
		}
	}
	
	public PName paGetTypeId(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("typeId");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(typeId);
		}
		catch(PException e){
			return null;
		}
	}

	public Object getMemoryInstance(){
		return this;
	}
	
	
	public String toString(){
		StringBuffer s = new StringBuffer();
		s.append("data(");
					s.append(itemId + ",  ");
					s.append(jonasCMROrder_Item + ",  ");
					s.append(jonasCMRUser_Item + ",  ");
					s.append(longDesc + ",  ");
					s.append(mainPage + ",  ");
					s.append(name + ",  ");
					s.append(pictures + ",  ");
					s.append(price + ",  ");
					s.append(properties + ",  ");
					s.append(shortDesc + ",  ");
					s.append(specialOffer + ",  ");
					s.append(typeId + ",  ");
				s.append(pName + ")");
		return s.toString();
	}
	
	
	public void read(PClassMapping pcm, PAccessor pa) throws PException{
		Olstore_itemAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PException("Accessor must not be null");
		else if (pa instanceof Olstore_itemAccessor)
			paccessor = (Olstore_itemAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PException("Wrong type of accessor: " + pa);
	 	try {	
			if(paccessor != null){
											paccessor.paSetItemId(paGetItemId());
															paccessor.paSetJonasCMROrder_Item(paGetJonasCMROrder_Item(pcm), null);
															paccessor.paSetJonasCMRUser_Item(paGetJonasCMRUser_Item(pcm), null);
															paccessor.paSetLongDesc(paGetLongDesc());
															paccessor.paSetMainPage(paGetMainPage());
															paccessor.paSetName(paGetName());
															paccessor.paSetPictures(paGetPictures(pcm), null);
															paccessor.paSetPrice(paGetPrice());
															paccessor.paSetProperties(paGetProperties(pcm), null);
															paccessor.paSetShortDesc(paGetShortDesc());
															paccessor.paSetSpecialOffer(paGetSpecialOffer());
															paccessor.paSetTypeId(paGetTypeId(pcm), null);
							 			}
 			else{
	  		 			        		//paccessorGen.paSetOintField("itemId", paGetItemId(pcm), null);
	        			 						 						 			        		//paccessorGen.paSetStringField("longDesc", paGetLongDesc(pcm), null);
	        			 			        		//paccessorGen.paSetObooleanField("mainPage", paGetMainPage(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("name", paGetName(pcm), null);
	        			 						 			        		//paccessorGen.paSetBigDecimalField("price", paGetPrice(pcm), null);
	        			 						 			        		//paccessorGen.paSetStringField("shortDesc", paGetShortDesc(pcm), null);
	        			 			        		//paccessorGen.paSetObooleanField("specialOffer", paGetSpecialOffer(pcm), null);
	        			 						        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
	
	public void write(PClassMapping pcm, PAccessor pa) throws PException{
		Olstore_itemAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PExceptionProtocol("Accessor must not be null");
		else if (pa instanceof Olstore_itemAccessor)
			paccessor = (Olstore_itemAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PExceptionProtocol("Wrong type of accessor: " + pa);
		try {	
			if(paccessor != null){
											paSetItemId(paccessor.paGetItemId());
															paSetJonasCMROrder_Item(paccessor.paGetJonasCMROrder_Item(pcm), null);
															paSetJonasCMRUser_Item(paccessor.paGetJonasCMRUser_Item(pcm), null);
															paSetLongDesc(paccessor.paGetLongDesc());
															paSetMainPage(paccessor.paGetMainPage());
															paSetName(paccessor.paGetName());
															paSetPictures(paccessor.paGetPictures(pcm), null);
															paSetPrice(paccessor.paGetPrice());
															paSetProperties(paccessor.paGetProperties(pcm), null);
															paSetShortDesc(paccessor.paGetShortDesc());
															paSetSpecialOffer(paccessor.paGetSpecialOffer());
															paSetTypeId(paccessor.paGetTypeId(pcm), null);
							 			}
 			else{
	  		 				        	//	paSetOintField(itemId, paccessorGen.paGetItemId());
        		//paSetOintField("itemId", paccessorGen.paGetOintField("itemId"));
        		//paSetItemId(paccessorGen.paGetOintField("itemId"), null);
	        			 						 						 				        	//	paSetStringField(longDesc, paccessorGen.paGetLongDesc());
        		//paSetStringField("longDesc", paccessorGen.paGetStringField("longDesc"));
        		//paSetLongDesc(paccessorGen.paGetStringField("longDesc"), null);
	        			 				        	//	paSetObooleanField(mainPage, paccessorGen.paGetMainPage());
        		//paSetObooleanField("mainPage", paccessorGen.paGetObooleanField("mainPage"));
        		//paSetMainPage(paccessorGen.paGetObooleanField("mainPage"), null);
	        			 				        	//	paSetStringField(name, paccessorGen.paGetName());
        		//paSetStringField("name", paccessorGen.paGetStringField("name"));
        		//paSetName(paccessorGen.paGetStringField("name"), null);
	        			 						 				        	//	paSetBigDecimalField(price, paccessorGen.paGetPrice());
        		//paSetBigDecimalField("price", paccessorGen.paGetBigDecimalField("price"));
        		//paSetPrice(paccessorGen.paGetBigDecimalField("price"), null);
	        			 						 				        	//	paSetStringField(shortDesc, paccessorGen.paGetShortDesc());
        		//paSetStringField("shortDesc", paccessorGen.paGetStringField("shortDesc"));
        		//paSetShortDesc(paccessorGen.paGetStringField("shortDesc"), null);
	        			 				        	//	paSetObooleanField(specialOffer, paccessorGen.paGetSpecialOffer());
        		//paSetObooleanField("specialOffer", paccessorGen.paGetObooleanField("specialOffer"));
        		//paSetSpecialOffer(paccessorGen.paGetObooleanField("specialOffer"), null);
	        			 						        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
}